diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/random-variable-stream.cc ns-3.31/src/core/model/random-variable-stream.cc
--- ns-3.30.1/src/core/model/random-variable-stream.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/random-variable-stream.cc	2020-06-27 17:38:30.000000000 -0700
@@ -1187,28 +1172,28 @@
     }
 }
 
-NS_OBJECT_ENSURE_REGISTERED(TriangularRandomVariable);
+NS_OBJECT_ENSURE_REGISTERED (TriangularRandomVariable);
 
-TypeId 
+TypeId
 TriangularRandomVariable::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::TriangularRandomVariable")
     .SetParent<RandomVariableStream>()
     .SetGroupName ("Core")
     .AddConstructor<TriangularRandomVariable> ()
-    .AddAttribute("Mean", "The mean value for the triangular distribution returned by this RNG stream.",
-		  DoubleValue(0.5),
-		  MakeDoubleAccessor(&TriangularRandomVariable::m_mean),
-		  MakeDoubleChecker<double>())
-    .AddAttribute("Min", "The lower bound on the values returned by this RNG stream.",
-		  DoubleValue(0.0),
-		  MakeDoubleAccessor(&TriangularRandomVariable::m_min),
-		  MakeDoubleChecker<double>())
-    .AddAttribute("Max", "The upper bound on the values returned by this RNG stream.",
-		  DoubleValue(1.0),
-		  MakeDoubleAccessor(&TriangularRandomVariable::m_max),
-		  MakeDoubleChecker<double>())
-    ;
+    .AddAttribute ("Mean", "The mean value for the triangular distribution returned by this RNG stream.",
+                   DoubleValue (0.5),
+                   MakeDoubleAccessor (&TriangularRandomVariable::m_mean),
+                   MakeDoubleChecker<double>())
+    .AddAttribute ("Min", "The lower bound on the values returned by this RNG stream.",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&TriangularRandomVariable::m_min),
+                   MakeDoubleChecker<double>())
+    .AddAttribute ("Max", "The upper bound on the values returned by this RNG stream.",
+                   DoubleValue (1.0),
+                   MakeDoubleAccessor (&TriangularRandomVariable::m_max),
+                   MakeDoubleChecker<double>())
+  ;
   return tid;
 }
 TriangularRandomVariable::TriangularRandomVariable ()
@@ -1218,26 +1203,26 @@
   NS_LOG_FUNCTION (this);
 }
 
-double 
+double
 TriangularRandomVariable::GetMean (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_mean;
 }
-double 
+double
 TriangularRandomVariable::GetMin (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_min;
 }
-double 
+double
 TriangularRandomVariable::GetMax (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_max;
 }
 
-double 
+double
 TriangularRandomVariable::GetValue (double mean, double min, double max)
 {
   // Calculate the mode.
@@ -1262,44 +1247,44 @@
     }
 }
 
-uint32_t 
+uint32_t
 TriangularRandomVariable::GetInteger (uint32_t mean, uint32_t min, uint32_t max)
 {
   NS_LOG_FUNCTION (this << mean << min << max);
   return static_cast<uint32_t> ( GetValue (mean, min, max) );
 }
 
-double 
+double
 TriangularRandomVariable::GetValue (void)
 {
   NS_LOG_FUNCTION (this);
   return GetValue (m_mean, m_min, m_max);
 }
-uint32_t 
+uint32_t
 TriangularRandomVariable::GetInteger (void)
 {
   NS_LOG_FUNCTION (this);
   return (uint32_t)GetValue (m_mean, m_min, m_max);
 }
 
-NS_OBJECT_ENSURE_REGISTERED(ZipfRandomVariable);
+NS_OBJECT_ENSURE_REGISTERED (ZipfRandomVariable);
 
-TypeId 
+TypeId
 ZipfRandomVariable::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ZipfRandomVariable")
     .SetParent<RandomVariableStream>()
     .SetGroupName ("Core")
     .AddConstructor<ZipfRandomVariable> ()
-    .AddAttribute("N", "The n value for the Zipf distribution returned by this RNG stream.",
-		  IntegerValue(1),
-		  MakeIntegerAccessor(&ZipfRandomVariable::m_n),
-		  MakeIntegerChecker<uint32_t>())
-    .AddAttribute("Alpha", "The alpha value for the Zipf distribution returned by this RNG stream.",
-		  DoubleValue(0.0),
-		  MakeDoubleAccessor(&ZipfRandomVariable::m_alpha),
-		  MakeDoubleChecker<double>())
-    ;
+    .AddAttribute ("N", "The n value for the Zipf distribution returned by this RNG stream.",
+                   IntegerValue (1),
+                   MakeIntegerAccessor (&ZipfRandomVariable::m_n),
+                   MakeIntegerChecker<uint32_t>())
+    .AddAttribute ("Alpha", "The alpha value for the Zipf distribution returned by this RNG stream.",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&ZipfRandomVariable::m_alpha),
+                   MakeDoubleChecker<double>())
+  ;
   return tid;
 }
 ZipfRandomVariable::ZipfRandomVariable ()
@@ -1308,20 +1293,20 @@
   NS_LOG_FUNCTION (this);
 }
 
-uint32_t 
+uint32_t
 ZipfRandomVariable::GetN (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_n;
 }
-double 
+double
 ZipfRandomVariable::GetAlpha (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_alpha;
 }
 
-double 
+double
 ZipfRandomVariable::GetValue (uint32_t n, double alpha)
 {
   NS_LOG_FUNCTION (this << n << alpha);
@@ -1353,40 +1338,40 @@
   return zipf_value;
 }
 
-uint32_t 
+uint32_t
 ZipfRandomVariable::GetInteger (uint32_t n, uint32_t alpha)
 {
   NS_LOG_FUNCTION (this << n << alpha);
   return static_cast<uint32_t> ( GetValue (n, alpha));
 }
 
-double 
+double
 ZipfRandomVariable::GetValue (void)
 {
   NS_LOG_FUNCTION (this);
   return GetValue (m_n, m_alpha);
 }
-uint32_t 
+uint32_t
 ZipfRandomVariable::GetInteger (void)
 {
   NS_LOG_FUNCTION (this);
   return (uint32_t)GetValue (m_n, m_alpha);
 }
 
-NS_OBJECT_ENSURE_REGISTERED(ZetaRandomVariable);
+NS_OBJECT_ENSURE_REGISTERED (ZetaRandomVariable);
 
-TypeId 
+TypeId
 ZetaRandomVariable::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ZetaRandomVariable")
     .SetParent<RandomVariableStream>()
     .SetGroupName ("Core")
     .AddConstructor<ZetaRandomVariable> ()
-    .AddAttribute("Alpha", "The alpha value for the zeta distribution returned by this RNG stream.",
-		  DoubleValue(3.14),
-		  MakeDoubleAccessor(&ZetaRandomVariable::m_alpha),
-		  MakeDoubleChecker<double>())
-    ;
+    .AddAttribute ("Alpha", "The alpha value for the zeta distribution returned by this RNG stream.",
+                   DoubleValue (3.14),
+                   MakeDoubleAccessor (&ZetaRandomVariable::m_alpha),
+                   MakeDoubleChecker<double>())
+  ;
   return tid;
 }
 ZetaRandomVariable::ZetaRandomVariable ()
@@ -1395,14 +1380,14 @@
   NS_LOG_FUNCTION (this);
 }
 
-double 
+double
 ZetaRandomVariable::GetAlpha (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_alpha;
 }
 
-double 
+double
 ZetaRandomVariable::GetValue (double alpha)
 {
   NS_LOG_FUNCTION (this << alpha);
@@ -1437,43 +1422,43 @@
   return X;
 }
 
-uint32_t 
+uint32_t
 ZetaRandomVariable::GetInteger (uint32_t alpha)
 {
   NS_LOG_FUNCTION (this << alpha);
   return static_cast<uint32_t> ( GetValue (alpha));
 }
 
-double 
+double
 ZetaRandomVariable::GetValue (void)
 {
   NS_LOG_FUNCTION (this);
   return GetValue (m_alpha);
 }
-uint32_t 
+uint32_t
 ZetaRandomVariable::GetInteger (void)
 {
   NS_LOG_FUNCTION (this);
   return (uint32_t)GetValue (m_alpha);
 }
 
-NS_OBJECT_ENSURE_REGISTERED(DeterministicRandomVariable);
+NS_OBJECT_ENSURE_REGISTERED (DeterministicRandomVariable);
 
-TypeId 
+TypeId
 DeterministicRandomVariable::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::DeterministicRandomVariable")
     .SetParent<RandomVariableStream>()
     .SetGroupName ("Core")
     .AddConstructor<DeterministicRandomVariable> ()
-    ;
+  ;
   return tid;
 }
 DeterministicRandomVariable::DeterministicRandomVariable ()
   :
-  m_count (0),
-  m_next (0),
-  m_data (0)
+    m_count (0),
+    m_next (0),
+    m_data (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -1482,9 +1467,9 @@
   // Delete any values currently set.
   NS_LOG_FUNCTION (this);
   if (m_data != 0)
-  {
-    delete[] m_data;
-  }
+    {
+      delete[] m_data;
+    }
 }
 
 void
@@ -1493,9 +1478,9 @@
   NS_LOG_FUNCTION (this << values << length);
   // Delete any values currently set.
   if (m_data != 0)
-  {
-    delete[] m_data;
-  }
+    {
+      delete[] m_data;
+    }
 
   // Make room for the values being set.
   m_data = new double[length];
@@ -1509,7 +1494,7 @@
     }
 }
 
-double 
+double
 DeterministicRandomVariable::GetValue (void)
 {
   NS_LOG_FUNCTION (this);
@@ -1523,22 +1508,23 @@
   return m_data[m_next++];
 }
 
-uint32_t 
+uint32_t
 DeterministicRandomVariable::GetInteger (void)
 {
   NS_LOG_FUNCTION (this);
   return (uint32_t)GetValue ();
 }
 
-NS_OBJECT_ENSURE_REGISTERED(EmpiricalRandomVariable);
+NS_OBJECT_ENSURE_REGISTERED (EmpiricalRandomVariable);
 
 // ValueCDF methods
-EmpiricalRandomVariable::ValueCDF::ValueCDF ()
+EmpiricalRandomVariable::ValueCDF::ValueCDF (void)
   : value (0.0),
     cdf (0.0)
 {
   NS_LOG_FUNCTION (this);
 }
+
 EmpiricalRandomVariable::ValueCDF::ValueCDF (double v, double c)
   : value (v),
     cdf (c)
@@ -1546,95 +1532,173 @@
   NS_LOG_FUNCTION (this << v << c);
   NS_ASSERT (c >= 0.0 && c <= 1.0);
 }
-EmpiricalRandomVariable::ValueCDF::ValueCDF (const ValueCDF& c)
-  : value (c.value),
-    cdf (c.cdf)
+
+bool
+operator < (EmpiricalRandomVariable::ValueCDF a,
+            EmpiricalRandomVariable::ValueCDF b)
 {
-  NS_LOG_FUNCTION (this << &c);
+  return a.cdf < b.cdf;
 }
 
-TypeId 
+TypeId
 EmpiricalRandomVariable::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::EmpiricalRandomVariable")
     .SetParent<RandomVariableStream>()
     .SetGroupName ("Core")
     .AddConstructor<EmpiricalRandomVariable> ()
-    ;
+    .AddAttribute ("Interpolate",
+                   "Treat the CDF as a smooth distribution and interpolate, "
+                   "default is to treat the CDF as a histogram and sample.",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&EmpiricalRandomVariable::m_interpolate),
+                   MakeBooleanChecker ())
+  ;
   return tid;
 }
-EmpiricalRandomVariable::EmpiricalRandomVariable ()
-  :
-  m_validated (false)
+EmpiricalRandomVariable::EmpiricalRandomVariable (void)
+  : m_validated (false)
 {
   NS_LOG_FUNCTION (this);
 }
 
-double 
-EmpiricalRandomVariable::GetValue (void)
+bool
+EmpiricalRandomVariable::SetInterpolate (bool interpolate)
+{
+  NS_LOG_FUNCTION (this << interpolate);
+  bool prev = m_interpolate;
+  m_interpolate = interpolate;
+  return prev;
+}
+
+uint32_t
+EmpiricalRandomVariable::GetInteger (void)
 {
   NS_LOG_FUNCTION (this);
-  // Return a value from the empirical distribution
-  // This code based (loosely) on code by Bruce Mah (Thanks Bruce!)
+  return static_cast<uint32_t> (GetValue ());
+}
+
+bool
+EmpiricalRandomVariable::PreSample (double & value)
+{
+  NS_LOG_FUNCTION (this);
+
   if (!m_validated)
     {
       Validate ();
     }
-
-  // Get a uniform random variable in [0,1].
+ 
+  // Get a uniform random variable in [0, 1].
   double r = Peek ()->RandU01 ();
   if (IsAntithetic ())
     {
       r = (1 - r);
     }
-
+ 
+  value = r;
+  bool valid = false;
+  // check extrema
   if (r <= m_emp.front ().cdf)
     {
-      return m_emp.front ().value; // Less than first
+      value = m_emp.front ().value; // Less than first
+      valid = true;
     }
-  if (r >= m_emp.back ().cdf)
+  else if (r >= m_emp.back ().cdf)
     {
-      return m_emp.back ().value;  // Greater than last
+      value = m_emp.back ().value;  // Greater than last
+      valid = true;
     }
-  // Binary search
-  std::vector<ValueCDF>::size_type bottom = 0;
-  std::vector<ValueCDF>::size_type top = m_emp.size () - 1;
-  while (1)
+  return valid;
+}
+
+double
+EmpiricalRandomVariable::GetValue (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  double value;
+  if (PreSample (value))
     {
-      std::vector<ValueCDF>::size_type c = (top + bottom) / 2;
-      if (r >= m_emp[c].cdf && r < m_emp[c + 1].cdf)
-        { // Found it
-          return Interpolate (m_emp[c].cdf, m_emp[c + 1].cdf,
-                              m_emp[c].value, m_emp[c + 1].value,
-                              r);
-        }
-      // Not here, adjust bounds
-      if (r < m_emp[c].cdf)
-        {
-          top    = c - 1;
-        }
-      else
-        {
-          bottom = c + 1;
-        }
+      return value;
+    }
+  
+  // value now has the (unused) URNG selector
+  if (m_interpolate)
+    {
+      value = DoInterpolate (value);
+    }
+  else
+    {
+      value = DoSampleCDF (value);
     }
+  return value;
 }
 
-uint32_t 
-EmpiricalRandomVariable::GetInteger (void)
+double
+EmpiricalRandomVariable::DoSampleCDF (double r)
+{
+  NS_LOG_FUNCTION (this << r);
+  
+  ValueCDF selector (0, r);
+  auto bound = std::upper_bound (m_emp.begin (), m_emp.end (), selector);
+  
+  return bound->value;
+}
+
+double
+EmpiricalRandomVariable::Interpolate (void)
 {
   NS_LOG_FUNCTION (this);
-  return (uint32_t)GetValue ();
+
+  double value;
+  if (PreSample (value))
+    {
+      return value;
+    }
+
+  // value now has the (unused) URNG selector
+  value = DoInterpolate (value);
+  return value;
+}
+
+double
+EmpiricalRandomVariable::DoInterpolate (double r)
+{
+  NS_LOG_FUNCTION (this << r);
+
+  // Return a value from the empirical distribution
+  // This code based (loosely) on code by Bruce Mah (Thanks Bruce!)
+
+  // search
+  ValueCDF selector (0, r);
+  auto upper = std::upper_bound (m_emp.begin (), m_emp.end (), selector);
+  auto lower = std::prev (upper, 1);
+  if (upper == m_emp.begin ())
+    {
+      lower = upper;
+    }
+
+  // Interpolate random value in range [v1..v2) based on [c1 .. r .. c2)
+  double c1 = lower->cdf;
+  double c2 = upper->cdf;
+  double v1 = lower->value;
+  double v2 = upper->value;
+  
+  double value = (v1 + ((v2 - v1) / (c2 - c1)) * (r - c1));
+  return value;
 }
 
-void EmpiricalRandomVariable::CDF (double v, double c)
-{ // Add a new empirical datapoint to the empirical cdf
+void
+EmpiricalRandomVariable::CDF (double v, double c)
+{
+  // Add a new empirical datapoint to the empirical cdf
   // NOTE.   These MUST be inserted in non-decreasing order
   NS_LOG_FUNCTION (this << v << c);
   m_emp.push_back (ValueCDF (v, c));
 }
 
-void EmpiricalRandomVariable::Validate ()
+void
+EmpiricalRandomVariable::Validate (void)
 {
   NS_LOG_FUNCTION (this);
   if (m_emp.empty ())
@@ -1642,15 +1706,14 @@
       NS_FATAL_ERROR ("CDF is not initialized");
     }
   ValueCDF prior = m_emp[0];
-  for (std::vector<ValueCDF>::size_type i = 0; i < m_emp.size (); ++i)
+  for (auto current : m_emp)
     {
-      ValueCDF& current = m_emp[i];
       if (current.value < prior.value || current.cdf < prior.cdf)
         { // Error
           std::cerr << "Empirical Dist error,"
-               << " current value " << current.value
-               << " prior value "   << prior.value
-               << " current cdf "   << current.cdf
+                    << " current value " << current.value
+                    << " prior value "   << prior.value
+                    << " current cdf "   << current.cdf
                     << " prior cdf "     << prior.cdf << std::endl;
           NS_FATAL_ERROR ("Empirical Dist error");
         }
@@ -1663,11 +1726,4 @@
   m_validated = true;
 }
 
-double EmpiricalRandomVariable::Interpolate (double c1, double c2,
-                                           double v1, double v2, double r)
-{ // Interpolate random value in range [v1..v2) based on [c1 .. r .. c2)
-  NS_LOG_FUNCTION (this << c1 << c2 << v1 << v2 << r);
-  return (v1 + ((v2 - v1) / (c2 - c1)) * (r - c1));
-}
-
 } // namespace ns3
